// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot.commands.grimpeur;

import edu.wpi.first.networktables.DoubleSubscriber;
import edu.wpi.first.networktables.NetworkTable;
import edu.wpi.first.networktables.NetworkTableInstance;
import edu.wpi.first.wpilibj2.command.Command;
import frc.robot.subsystems.Grimpeur;

/* You should consider using the more terse Command factories API instead https://docs.wpilib.org/en/stable/docs/software/commandbased/organizing-command-based.html#defining-commands */
public class GrimpeurBas extends Command {
  private Grimpeur grimpeur;
   NetworkTableInstance networktable = NetworkTableInstance.getDefault();
  NetworkTable tabelevateur = networktable.getTable("tabelevateur");
  private DoubleSubscriber encodeur1 = tabelevateur.getDoubleTopic("encodeurgrimpeurbas").subscribe(-39.19);
  private DoubleSubscriber encodeur2 = tabelevateur.getDoubleTopic("encodeurgrimpeurhaut ").subscribe(-38.5);
  /** Creates a new GrimpeurBas. */
  public GrimpeurBas(Grimpeur grimpeur) {
    this.grimpeur = grimpeur;
    addRequirements(grimpeur);
    // Use addRequirements() here to declare subsystem dependencies.
  }

  // Called when the command is initially scheduled.
  @Override
  public void initialize() {}

  // Called every time the scheduler runs while the command is scheduled.
  @Override
  public void execute() {
    double encodeurbas = encodeur1.get();
    double encodeurhaut = encodeur2.get();
    if(grimpeur.encodeur()>=encodeurhaut && grimpeur.encodeur()<=encodeurbas){
      grimpeur.grimpe(0);
    }
    else if(grimpeur.encodeur()>=encodeurhaut){
      grimpeur.grimpe(-0.5);
    }
   else{grimpeur.grimpe(0.5);
  } 
  }

  // Called once the command ends or is interrupted.
  @Override
  public void end(boolean interrupted) {
    grimpeur.grimpe(0);
  }

  // Returns true when the command should end.
  @Override
  public boolean isFinished() {
    return false;
  }
}
